<template>
  <q-dialog class="q-pa-md q-gutter-md" ref="dialog" v-on:hide="onDialogHide">
    <q-card>
      <q-card-section class="row justify-between">
        <div class="text-h6">Iniciar Sesión</div>
        <q-btn
          icon="close"
          flat
          round
          dense
          v-close-popup
        />
      </q-card-section>

      <q-card-section class="row justify-center">
        <q-form
          v-on:submit="logIn"
          class="q-gutter-md"
        >
        <q-input
          autocomplete="email"
          outlined
          v-model="email"
          placeholder="Correo"
          hint="Correo"
          lazy-rules
          v-bind:rules="[ val => val && val.length > 0 || 'Por favor ingrese su correo']"
        />

        <q-input
          autocomplete="current-password"
          v-model="password"
          outlined
          type="password"
          placeholder="Contraseña"
          hint="Contraseña"
        />
          <q-btn
            v-bind:loading="authData.isLoggingIn"
            label="¿Olvidó su contraseña?"
            flat
            v-on:click="forgot"
            color="secondary"
          />
        <div class="row justify-center" horizontal>
          <q-btn
            v-bind:loading="authData.isLoggingIn"
            label="Ingresar"
            type="submit"
            color="primary"
          />
          <q-btn
            v-bind:loading="authData.isLoggingIn"
            label="Cancelar"
            flat
            v-on:click="onCancelClick"
            color="primary"
          />
        </div>
      </q-form>
    </q-card-section>
  </q-card>
</q-dialog>
</template>

<script>
import { mapState } from 'vuex'

export default {
  name: 'LoginDialog',
  data () {
    return {
      email: null,
      password: null
    }
  },
  computed: {
    ...mapState({
      authData: state => state.auth
    })
  },
  methods: {
    show () {
      this.$refs.dialog.show()
    },

    hide () {
      this.$refs.dialog.hide()
    },

    onDialogHide () {
      this.$emit('hide')
    },

    onCancelClick () {
      this.hide()
    },
    forgot () {
      this.hide()
      this.$q.notify({ color: 'warning', textColor: 'white', icon: 'check_circle', message: 'Se ha solicitado una nueva contraseña para su correo: ' + this.email })
      this.$connection.post('forgot', { email: this.email }, { 'Access-Control-Expose-Headers': 'Authorization' })
        .then((response) => {
          this.$q.notify({ color: 'warning', textColor: 'white', icon: 'check_circle', message: 'Se ha enviado un correo con su nueva contraseña.' })
        })
        .catch(() => {
          this.$q.notify({ color: 'negative', textColor: 'white', icon: 'cancel', message: 'Ha habido un error al enviar la contraseña a su correo. Por favor vuelva a ingresar su correo e intente nuevamente.' })
        })
    },
    logIn () {
      this.$emit('ok')
      this.hide()
      this.$store.dispatch('auth/logIn',
        { email: this.email, password: this.password }
      )
    }
  }
}
</script>
